Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/src/Instruction.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/src/Instruction.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/src/Instruction.cpp	(revision 88)
@@ -853,6 +901,6 @@
     else
       {
-    inst->_type               = TYPE_BRANCH;
-    inst->_operation          = OPERATION_BRANCH_L_JALR;
+    inst->_type               = instruction_information(INSTRUCTION_L_JALR)._type     ; //TYPE_BRANCH;
+    inst->_operation          = instruction_information(INSTRUCTION_L_JALR)._operation; //OPERATION_BRANCH_L_JALR;
     inst->_has_immediat       = 0;
 //  inst->_immediat           = ;
@@ -868,4 +916,5 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
 //  inst->_branch_condition   = (inst->_num_reg_rb == 9)?BRANCH_CONDITION_READ_STACK:BRANCH_CONDITION_READ_REGISTER;
     inst->_branch_condition   = BRANCH_CONDITION_READ_REGISTER_WITH_WRITE_STACK;
@@ -873,4 +922,5 @@
     inst->_branch_direction   = 1;
 //  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
       }
@@ -881,6 +931,6 @@
     log_printf(TRACE,Decod,"instruction_l_jr","  * instruction   : l.jr");
 
-    inst->_type               = TYPE_BRANCH;
-    inst->_operation          = OPERATION_BRANCH_L_JALR;
+    inst->_type               = instruction_information(INSTRUCTION_L_JR)._type     ; //TYPE_BRANCH;
+    inst->_operation          = instruction_information(INSTRUCTION_L_JR)._operation; //OPERATION_BRANCH_L_JALR;
     inst->_has_immediat       = 0;
 //  inst->_immediat           = ;
@@ -896,8 +946,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
     inst->_branch_condition   = (inst->_num_reg_rb == 9)?BRANCH_CONDITION_READ_STACK:BRANCH_CONDITION_READ_REGISTER_WITHOUT_WRITE_STACK;
 //  inst->_branch_stack_write = 0;
     inst->_branch_direction   = 1;
 //  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -907,6 +959,6 @@
     log_printf(TRACE,Decod,"instruction_l_lbs","  * instruction   : l.lbs");
 
-    inst->_type               = TYPE_MEMORY;
-    inst->_operation          = OPERATION_MEMORY_LOAD_8_S;
+    inst->_type               = instruction_information(INSTRUCTION_L_LBS)._type     ; //TYPE_MEMORY;
+    inst->_operation          = instruction_information(INSTRUCTION_L_LBS)._operation; //OPERATION_MEMORY_LOAD_8_S;
     inst->_has_immediat       = 1;
     inst->_immediat           = EXTENDS(inst->_instruction,16);
@@ -922,8 +974,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_MEMORY_WITHOUT_ALIGNMENT;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -933,6 +987,6 @@
     log_printf(TRACE,Decod,"instruction_l_lbz","  * instruction   : l.lbz");
 
-    inst->_type               = TYPE_MEMORY;
-    inst->_operation          = OPERATION_MEMORY_LOAD_8_Z;
+    inst->_type               = instruction_information(INSTRUCTION_L_LBZ)._type     ; //TYPE_MEMORY;
+    inst->_operation          = instruction_information(INSTRUCTION_L_LBZ)._operation; //OPERATION_MEMORY_LOAD_8_Z;
     inst->_has_immediat       = 1;
     inst->_immediat           = EXTENDS(inst->_instruction,16);
@@ -948,8 +1002,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_MEMORY_WITHOUT_ALIGNMENT;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -959,6 +1015,6 @@
     log_printf(TRACE,Decod,"instruction_l_ld","  * instruction   : l.ld");
 
-    inst->_type               = TYPE_MEMORY;
-    inst->_operation          = OPERATION_MEMORY_LOAD_64_S;
+    inst->_type               = instruction_information(INSTRUCTION_L_LD)._type     ; //TYPE_MEMORY;
+    inst->_operation          = instruction_information(INSTRUCTION_L_LD)._operation; //OPERATION_MEMORY_LOAD_64_S;
     inst->_has_immediat       = 1;
     inst->_immediat           = EXTENDS(inst->_instruction,16);
@@ -974,8 +1030,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_MEMORY_WITH_ALIGNMENT;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -985,6 +1043,6 @@
     log_printf(TRACE,Decod,"instruction_l_lhs","  * instruction   : l.lhs");
 
-    inst->_type               = TYPE_MEMORY;
-    inst->_operation          = OPERATION_MEMORY_LOAD_16_S;
+    inst->_type               = instruction_information(INSTRUCTION_L_LHS)._type     ; //TYPE_MEMORY;
+    inst->_operation          = instruction_information(INSTRUCTION_L_LHS)._operation; //OPERATION_MEMORY_LOAD_16_S;
     inst->_has_immediat       = 1;
     inst->_immediat           = EXTENDS(inst->_instruction,16);
@@ -1000,8 +1058,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_MEMORY_WITH_ALIGNMENT;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -1011,6 +1071,6 @@
     log_printf(TRACE,Decod,"instruction_l_lhz","  * instruction   : l.lhz");
 
-    inst->_type               = TYPE_MEMORY;
-    inst->_operation          = OPERATION_MEMORY_LOAD_16_Z;
+    inst->_type               = instruction_information(INSTRUCTION_L_LHZ)._type     ; //TYPE_MEMORY;
+    inst->_operation          = instruction_information(INSTRUCTION_L_LHZ)._operation; //OPERATION_MEMORY_LOAD_16_Z;
     inst->_has_immediat       = 1;
     inst->_immediat           = EXTENDS(inst->_instruction,16);
@@ -1026,8 +1086,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_MEMORY_WITH_ALIGNMENT;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -1037,6 +1099,6 @@
     log_printf(TRACE,Decod,"instruction_l_lws","  * instruction   : l.lws");
 
-    inst->_type               = TYPE_MEMORY;
-    inst->_operation          = OPERATION_MEMORY_LOAD_32_S;
+    inst->_type               = instruction_information(INSTRUCTION_L_LWS)._type     ; //TYPE_MEMORY;
+    inst->_operation          = instruction_information(INSTRUCTION_L_LWS)._operation; //OPERATION_MEMORY_LOAD_32_S;
     inst->_has_immediat       = 1;
     inst->_immediat           = EXTENDS(inst->_instruction,16);
@@ -1052,8 +1114,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_MEMORY_WITH_ALIGNMENT;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -1063,6 +1127,6 @@
     log_printf(TRACE,Decod,"instruction_l_lwz","  * instruction   : l.lwz");
 
-    inst->_type               = TYPE_MEMORY;
-    inst->_operation          = OPERATION_MEMORY_LOAD_32_Z;
+    inst->_type               = instruction_information(INSTRUCTION_L_LWZ)._type     ; //TYPE_MEMORY;
+    inst->_operation          = instruction_information(INSTRUCTION_L_LWZ)._operation; //OPERATION_MEMORY_LOAD_32_Z;
     inst->_has_immediat       = 1;
     inst->_immediat           = EXTENDS(inst->_instruction,16);
@@ -1078,8 +1142,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_MEMORY_WITH_ALIGNMENT;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -1089,23 +1155,25 @@
     log_printf(TRACE,Decod,"instruction_l_mac","  * instruction   : l.mac");
 
-    inst->_type               = TYPE_SPECIAL;
-    inst->_operation          = OPERATION_SPECIAL_L_MAC;
-    inst->_has_immediat       = 0;
-//  inst->_immediat           = ;
-    inst->_read_ra            = 1;
-    inst->_num_reg_ra         = range<Tgeneral_address_t>(inst->_instruction,20,16);
-    inst->_read_rb            = 1;
-    inst->_num_reg_rb         = range<Tgeneral_address_t>(inst->_instruction,15,11);
-    inst->_read_rc            = 0;
-//  inst->_num_reg_rc         = ;
-    inst->_write_rd           = 0;
-//  inst->_num_reg_rd         = ;
-    inst->_write_re           = 0;
-//  inst->_num_reg_re         = ;
-    inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_type               = instruction_information(INSTRUCTION_L_MAC)._type     ; //TYPE_SPECIAL;
+    inst->_operation          = instruction_information(INSTRUCTION_L_MAC)._operation; //OPERATION_SPECIAL_L_MAC;
+    inst->_has_immediat       = 0;
+//  inst->_immediat           = ;
+    inst->_read_ra            = 1;
+    inst->_num_reg_ra         = range<Tgeneral_address_t>(inst->_instruction,20,16);
+    inst->_read_rb            = 1;
+    inst->_num_reg_rb         = range<Tgeneral_address_t>(inst->_instruction,15,11);
+    inst->_read_rc            = 0;
+//  inst->_num_reg_rc         = ;
+    inst->_write_rd           = 0;
+//  inst->_num_reg_rd         = ;
+    inst->_write_re           = 0;
+//  inst->_num_reg_re         = ;
+    inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
 //  inst->_branch_condition   = ;
 //  inst->_branch_stack_write = ;
 //  inst->_branch_direction   = ;
 //  inst->_address_next       = ; // don't change
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_SPR_ACCESS;
   }
@@ -1115,6 +1183,6 @@
     log_printf(TRACE,Decod,"instruction_l_maci","  * instruction   : l.maci");
 
-    inst->_type               = TYPE_SPECIAL;
-    inst->_operation          = OPERATION_SPECIAL_L_MAC;
+    inst->_type               = instruction_information(INSTRUCTION_L_MACI)._type     ; //TYPE_SPECIAL;
+    inst->_operation          = instruction_information(INSTRUCTION_L_MACI)._operation; //OPERATION_SPECIAL_L_MAC;
     inst->_has_immediat       = 1;
     inst->_immediat           = EXTENDS(((range<Tgeneral_data_t   >(inst->_instruction,25,21)<<11)|
@@ -1131,8 +1199,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
 //  inst->_branch_condition   = ;
 //  inst->_branch_stack_write = ;
 //  inst->_branch_direction   = ;
 //  inst->_address_next       = ; // don't change
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_SPR_ACCESS;
   }
@@ -1148,6 +1218,6 @@
     else
       {
-    inst->_type               = TYPE_SPECIAL;
-    inst->_operation          = OPERATION_SPECIAL_L_MACRC;
+    inst->_type               = instruction_information(INSTRUCTION_L_MACRC)._type     ; //TYPE_SPECIAL;
+    inst->_operation          = instruction_information(INSTRUCTION_L_MACRC)._operation; //OPERATION_SPECIAL_L_MACRC;
     inst->_has_immediat       = 0;
 //  inst->_immediat           = ;
@@ -1163,8 +1233,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
 //  inst->_branch_condition   = ;
 //  inst->_branch_stack_write = ;
 //  inst->_branch_direction   = ;
 //  inst->_address_next       = ; // don't change
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_SPR_ACCESS;
       }
@@ -1175,6 +1247,6 @@
     log_printf(TRACE,Decod,"instruction_l_mfspr","  * instruction   : l.mfspr");
 
-    inst->_type               = TYPE_SPECIAL;
-    inst->_operation          = OPERATION_SPECIAL_L_MFSPR;
+    inst->_type               = instruction_information(INSTRUCTION_L_MFSPR)._type     ; //TYPE_SPECIAL;
+    inst->_operation          = instruction_information(INSTRUCTION_L_MFSPR)._operation; //OPERATION_SPECIAL_L_MFSPR;
     inst->_has_immediat       = 1;
     inst->_immediat           = EXTENDZ(inst->_instruction,16);
@@ -1190,8 +1262,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
 //  inst->_branch_condition   = ;
 //  inst->_branch_stack_write = ;
 //  inst->_branch_direction   = ;
 //  inst->_address_next       = ; // don't change
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_SPR_ACCESS;
   }
@@ -1201,6 +1275,6 @@
     log_printf(TRACE,Decod,"instruction_l_movhi","  * instruction   : l.movhi");
 
-    inst->_type               = TYPE_MOVE;
-    inst->_operation          = OPERATION_MOVE_L_MOVHI;
+    inst->_type               = instruction_information(INSTRUCTION_L_MOVHI)._type     ; //TYPE_MOVE;
+    inst->_operation          = instruction_information(INSTRUCTION_L_MOVHI)._operation; //OPERATION_MOVE_L_MOVHI;
     inst->_has_immediat       = 1;
     inst->_immediat           = EXTENDZ(inst->_instruction,16);
@@ -1216,8 +1290,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_NONE;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -1227,23 +1303,25 @@
     log_printf(TRACE,Decod,"instruction_l_msb","  * instruction   : l.msb");
 
-    inst->_type               = TYPE_SPECIAL;
-    inst->_operation          = OPERATION_SPECIAL_L_MSB;
-    inst->_has_immediat       = 0;
-//  inst->_immediat           = ;
-    inst->_read_ra            = 1;
-    inst->_num_reg_ra         = range<Tgeneral_address_t>(inst->_instruction,20,16);
-    inst->_read_rb            = 1;
-    inst->_num_reg_rb         = range<Tgeneral_address_t>(inst->_instruction,15,11);
-    inst->_read_rc            = 0;
-//  inst->_num_reg_rc         = ;
-    inst->_write_rd           = 0;
-//  inst->_num_reg_rd         = ;
-    inst->_write_re           = 0;
-//  inst->_num_reg_re         = ;
-    inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_type               = instruction_information(INSTRUCTION_L_MSB)._type     ; //TYPE_SPECIAL;
+    inst->_operation          = instruction_information(INSTRUCTION_L_MSB)._operation; //OPERATION_SPECIAL_L_MSB;
+    inst->_has_immediat       = 0;
+//  inst->_immediat           = ;
+    inst->_read_ra            = 1;
+    inst->_num_reg_ra         = range<Tgeneral_address_t>(inst->_instruction,20,16);
+    inst->_read_rb            = 1;
+    inst->_num_reg_rb         = range<Tgeneral_address_t>(inst->_instruction,15,11);
+    inst->_read_rc            = 0;
+//  inst->_num_reg_rc         = ;
+    inst->_write_rd           = 0;
+//  inst->_num_reg_rd         = ;
+    inst->_write_re           = 0;
+//  inst->_num_reg_re         = ;
+    inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
 //  inst->_branch_condition   = ;
 //  inst->_branch_stack_write = ;
 //  inst->_branch_direction   = ;
 //  inst->_address_next       = ; // don't change
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_SPR_ACCESS;
   }
@@ -1259,6 +1337,6 @@
     else
       {
-    inst->_type               = TYPE_SPECIAL;
-    inst->_operation          = OPERATION_SPECIAL_L_MSYNC;
+    inst->_type               = instruction_information(INSTRUCTION_L_MSYNC)._type     ; //TYPE_SPECIAL;
+    inst->_operation          = instruction_information(INSTRUCTION_L_MSYNC)._operation; //OPERATION_SPECIAL_L_MSYNC;
     inst->_has_immediat       = 0;
 //  inst->_immediat           = ;
@@ -1274,8 +1352,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
 //  inst->_branch_condition   = ;
 //  inst->_branch_stack_write = ;
 //  inst->_branch_direction   = ;
 //  inst->_address_next       = ; // don't change
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_MSYNC;
       }
@@ -1286,6 +1366,6 @@
     log_printf(TRACE,Decod,"instruction_l_mtspr","  * instruction   : l.mtspr");
 
-    inst->_type               = TYPE_SPECIAL;
-    inst->_operation          = OPERATION_SPECIAL_L_MTSPR;
+    inst->_type               = instruction_information(INSTRUCTION_L_MTSPR)._type     ; //TYPE_SPECIAL;
+    inst->_operation          = instruction_information(INSTRUCTION_L_MTSPR)._operation; //OPERATION_SPECIAL_L_MTSPR;
     inst->_has_immediat       = 1;
     inst->_immediat           = EXTENDZ(((range<Tgeneral_data_t   >(inst->_instruction,25,21)<<11)|
@@ -1302,8 +1382,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
 //  inst->_branch_condition   = ;
 //  inst->_branch_stack_write = ;
 //  inst->_branch_direction   = ;
 //  inst->_address_next       = ; // don't change
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_SPR_ACCESS;
   }
@@ -1313,6 +1395,6 @@
     log_printf(TRACE,Decod,"instruction_l_mul","  * instruction   : l.mul");
 
-    inst->_type               = TYPE_MUL_DIV;
-    inst->_operation          = OPERATION_MUL_DIV_L_MUL;
+    inst->_type               = instruction_information(INSTRUCTION_L_MUL)._type     ; //TYPE_MUL;
+    inst->_operation          = instruction_information(INSTRUCTION_L_MUL)._operation; //OPERATION_MUL_L_MUL;
     inst->_has_immediat       = 0;
 //  inst->_immediat           = ;
@@ -1328,8 +1410,10 @@
     inst->_num_reg_re         = SPR_LOGIC_SR_CY_OV;
     inst->_exception_use      = EXCEPTION_USE_RANGE;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -1339,6 +1423,6 @@
     log_printf(TRACE,Decod,"instruction_l_muli","  * instruction   : l.muli");
 
-    inst->_type               = TYPE_MUL_DIV;
-    inst->_operation          = OPERATION_MUL_DIV_L_MUL;
+    inst->_type               = instruction_information(INSTRUCTION_L_MULI)._type     ; //TYPE_MUL;
+    inst->_operation          = instruction_information(INSTRUCTION_L_MULI)._operation; //OPERATION_MUL_L_MUL;
     inst->_has_immediat       = 1;
     inst->_immediat           = EXTENDS(inst->_instruction,16);
@@ -1354,8 +1438,10 @@
     inst->_num_reg_re         = SPR_LOGIC_SR_CY_OV;
     inst->_exception_use      = EXCEPTION_USE_RANGE;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -1365,6 +1451,6 @@
     log_printf(TRACE,Decod,"instruction_l_mulu","  * instruction   : l.mulu");
 
-    inst->_type               = TYPE_MUL_DIV;
-    inst->_operation          = OPERATION_MUL_DIV_L_MULU;
+    inst->_type               = instruction_information(INSTRUCTION_L_MULU)._type     ; //TYPE_MUL;
+    inst->_operation          = instruction_information(INSTRUCTION_L_MULU)._operation; //OPERATION_MUL_L_MULU;
     inst->_has_immediat       = 0;
 //  inst->_immediat           = ;
@@ -1380,8 +1466,10 @@
     inst->_num_reg_re         = SPR_LOGIC_SR_CY_OV;
     inst->_exception_use      = EXCEPTION_USE_RANGE;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -1391,6 +1479,6 @@
     log_printf(TRACE,Decod,"instruction_l_nop","  * instruction   : l.nop");
 
-    inst->_type               = TYPE_SPECIAL;
-    inst->_operation          = OPERATION_SPECIAL_L_NOP;
+    inst->_type               = instruction_information(INSTRUCTION_L_NOP)._type     ; //TYPE_SPECIAL;
+    inst->_operation          = instruction_information(INSTRUCTION_L_NOP)._operation; //OPERATION_SPECIAL_L_NOP;
 //  inst->_has_immediat       = 1;
 //  inst->_immediat           = EXTENDZ(inst->_instruction,16);
@@ -1408,8 +1496,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_NONE;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 1;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -1419,23 +1509,25 @@
     log_printf(TRACE,Decod,"instruction_l_or","  * instruction   : l.or");
 
-    inst->_type               = TYPE_ALU;
-    inst->_operation          = OPERATION_ALU_L_OR;
-    inst->_has_immediat       = 0;
-//  inst->_immediat           = ;
-    inst->_read_ra            = 1;
-    inst->_num_reg_ra         = range<Tgeneral_address_t>(inst->_instruction,20,16);
-    inst->_read_rb            = 1;
-    inst->_num_reg_rb         = range<Tgeneral_address_t>(inst->_instruction,15,11);
-    inst->_read_rc            = 0;
-//  inst->_num_reg_rc         = ;
-    inst->_write_rd           = 1;
-    inst->_num_reg_rd         = range<Tgeneral_address_t>(inst->_instruction,25,21);
-    inst->_write_re           = 0;
-//  inst->_num_reg_re         = ;
-    inst->_exception_use      = EXCEPTION_USE_NONE;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_type               = instruction_information(INSTRUCTION_L_OR)._type     ; //TYPE_ALU;
+    inst->_operation          = instruction_information(INSTRUCTION_L_OR)._operation; //OPERATION_ALU_L_OR;
+    inst->_has_immediat       = 0;
+//  inst->_immediat           = ;
+    inst->_read_ra            = 1;
+    inst->_num_reg_ra         = range<Tgeneral_address_t>(inst->_instruction,20,16);
+    inst->_read_rb            = 1;
+    inst->_num_reg_rb         = range<Tgeneral_address_t>(inst->_instruction,15,11);
+    inst->_read_rc            = 0;
+//  inst->_num_reg_rc         = ;
+    inst->_write_rd           = 1;
+    inst->_num_reg_rd         = range<Tgeneral_address_t>(inst->_instruction,25,21);
+    inst->_write_re           = 0;
+//  inst->_num_reg_re         = ;
+    inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -1445,6 +1537,6 @@
     log_printf(TRACE,Decod,"instruction_l_ori","  * instruction   : l.ori");
 
-    inst->_type               = TYPE_ALU;
-    inst->_operation          = OPERATION_ALU_L_OR;
+    inst->_type               = instruction_information(INSTRUCTION_L_ORI)._type     ; //TYPE_ALU;
+    inst->_operation          = instruction_information(INSTRUCTION_L_ORI)._operation; //OPERATION_ALU_L_OR;
     inst->_has_immediat       = 1;
     inst->_immediat           = EXTENDZ(inst->_instruction,16);
@@ -1460,8 +1552,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_NONE;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -1477,6 +1571,6 @@
     else
       {
-    inst->_type               = TYPE_SPECIAL;
-    inst->_operation          = OPERATION_SPECIAL_L_PSYNC;
+    inst->_type               = instruction_information(INSTRUCTION_L_PSYNC)._type     ; //TYPE_SPECIAL;
+    inst->_operation          = instruction_information(INSTRUCTION_L_PSYNC)._operation; //OPERATION_SPECIAL_L_PSYNC;
     inst->_has_immediat       = 0;
 //  inst->_immediat           = ;
@@ -1492,8 +1586,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
 //  inst->_branch_condition   = ;
 //  inst->_branch_stack_write = ;
 //  inst->_branch_direction   = ;
 //  inst->_address_next       = ; // don't change
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_PSYNC;
       }
@@ -1504,6 +1600,6 @@
     log_printf(TRACE,Decod,"instruction_l_rfe","  * instruction   : l.rfe");
 
-    inst->_type               = TYPE_SPECIAL;
-    inst->_operation          = OPERATION_SPECIAL_L_RFE;
+    inst->_type               = instruction_information(INSTRUCTION_L_RFE)._type     ; //TYPE_SPECIAL;
+    inst->_operation          = instruction_information(INSTRUCTION_L_RFE)._operation; //OPERATION_SPECIAL_L_RFE;
     inst->_has_immediat       = 0;
 //  inst->_immediat           = ;
@@ -1519,8 +1615,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
 //  inst->_branch_condition   = ;
 //  inst->_branch_stack_write = ;
 //  inst->_branch_direction   = ;
 //  inst->_address_next       = ; // don't change
+    inst->_no_execute         = 1;
     inst->_event_type         = EVENT_TYPE_NONE; // can't anticip this instruction : must read EPCR in rename stage
   }
@@ -1530,23 +1628,25 @@
     log_printf(TRACE,Decod,"instruction_l_ror","  * instruction   : l.ror");
 
-    inst->_type               = TYPE_SHIFT;
-    inst->_operation          = OPERATION_SHIFT_L_ROR;
-    inst->_has_immediat       = 0;
-//  inst->_immediat           = ;
-    inst->_read_ra            = 1;
-    inst->_num_reg_ra         = range<Tgeneral_address_t>(inst->_instruction,20,16);
-    inst->_read_rb            = 1;
-    inst->_num_reg_rb         = range<Tgeneral_address_t>(inst->_instruction,15,11);
-    inst->_read_rc            = 0;
-//  inst->_num_reg_rc         = ;
-    inst->_write_rd           = 1;
-    inst->_num_reg_rd         = range<Tgeneral_address_t>(inst->_instruction,25,21);
-    inst->_write_re           = 0;
-//  inst->_num_reg_re         = ;
-    inst->_exception_use      = EXCEPTION_USE_NONE;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_type               = instruction_information(INSTRUCTION_L_ROR)._type     ; //TYPE_SHIFT;
+    inst->_operation          = instruction_information(INSTRUCTION_L_ROR)._operation; //OPERATION_SHIFT_L_ROR;
+    inst->_has_immediat       = 0;
+//  inst->_immediat           = ;
+    inst->_read_ra            = 1;
+    inst->_num_reg_ra         = range<Tgeneral_address_t>(inst->_instruction,20,16);
+    inst->_read_rb            = 1;
+    inst->_num_reg_rb         = range<Tgeneral_address_t>(inst->_instruction,15,11);
+    inst->_read_rc            = 0;
+//  inst->_num_reg_rc         = ;
+    inst->_write_rd           = 1;
+    inst->_num_reg_rd         = range<Tgeneral_address_t>(inst->_instruction,25,21);
+    inst->_write_re           = 0;
+//  inst->_num_reg_re         = ;
+    inst->_exception_use      = EXCEPTION_USE_NONE;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
@@ -1556,6 +1656,6 @@
     log_printf(TRACE,Decod,"instruction_l_rori","  * instruction   : l.rori");
 
-    inst->_type               = TYPE_SHIFT;
-    inst->_operation          = OPERATION_SHIFT_L_ROR;
+    inst->_type               = instruction_information(INSTRUCTION_L_RORI)._type     ; //TYPE_SHIFT;
+    inst->_operation          = instruction_information(INSTRUCTION_L_RORI)._operation; //OPERATION_SHIFT_L_ROR;
     inst->_has_immediat       = 1;
     inst->_immediat           = range<Tgeneral_data_t   >(inst->_instruction, 5, 0);
@@ -1571,8 +1671,10 @@
 //  inst->_num_reg_re         = ;
     inst->_exception_use      = EXCEPTION_USE_NONE;
-//  inst->_branch_condition   = ;
-//  inst->_branch_stack_write = ;
-//  inst->_branch_direction   = ;
-//  inst->_address_next       = ;
+    inst->_exception          = EXCEPTION_DECOD_NONE;
+//  inst->_branch_condition   = ;
+//  inst->_branch_stack_write = ;
+//  inst->_branch_direction   = ;
+//  inst->_address_next       = ;
+    inst->_no_execute         = 0;
     inst->_event_type         = EVENT_TYPE_NONE;
   }
